## socket-wrapper 1.4.2

=== CMakeLists.txt ===
# Required cmake version
cmake_minimum_required(VERSION 3.5.0)
cmake_policy(SET CMP0048 NEW)

# Specify search path for CMake modules to be loaded by include()
# and find_package()
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules")

# Add defaults for cmake
# Those need to be set before the project() call.
include(DefineCMakeDefaults)
include(DefineCompilerFlags)

project(socket_wrapper VERSION 1.4.2 LANGUAGES C)

# global needed variables
set(APPLICATION_NAME ${PROJECT_NAME})

# SOVERSION scheme: MAJOR.MINOR.PATCH
#   If there was an incompatible interface change:
#     Increment MAJOR. Set MINOR and PATCH to 0
#   If there was a compatible interface change:
#     Increment MINOR. Set PATCH to 0
#   If the source code was changed, but there were no interface changes:
#     Increment PATCH.
set(LIBRARY_VERSION_MAJOR 0)
set(LIBRARY_VERSION_MINOR 4)
set(LIBRARY_VERSION_PATCH 1)
set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(LIBRARY_SOVERSION ${LIBRARY_VERSION_MAJOR})

set(NOOP_LIBRARY_VERSION_MAJOR 0)
set(NOOP_LIBRARY_VERSION_MINOR 0)
set(NOOP_LIBRARY_VERSION_PATCH 1)
set(NOOP_LIBRARY_VERSION "${NOOP_LIBRARY_VERSION_MAJOR}.${NOOP_LIBRARY_VERSION_MINOR}.${NOOP_LIBRARY_VERSION_PATCH}")
set(NOOP_LIBRARY_SOVERSION ${NOOP_LIBRARY_VERSION_MAJOR})

# add definitions
include(DefinePlatformDefaults)
include(DefineOptions.cmake)
include(CPackConfig.cmake)
include(CompilerChecks.cmake)
include(GNUInstallDirs)

# disallow in-source build
include(MacroEnsureOutOfSourceBuild)
macro_ensure_out_of_source_build("${PROJECT_NAME} requires an out of source build. Please create a separate build directory and run 'cmake /path/to/${PROJECT_NAME} [options]' there.")

# Find out if we have threading available
set(CMAKE_THREAD_PREFER_PTHREADS ON)
find_package(Threads)

# config.h checks
include(ConfigureChecks.cmake)
configure_file(config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

# check subdirectories
add_subdirectory(src)

if (UNIT_TESTING)
    find_package(cmocka 1.1.0 REQUIRED)

    include(AddCMockaTest)
    add_subdirectory(tests)
endif (UNIT_TESTING)

# pkg-config file
get_filename_component(SOCKET_WRAPPER_LIB ${SOCKET_WRAPPER_LOCATION} NAME)

configure_file(socket_wrapper.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper.pc @ONLY)
install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper.pc
  DESTINATION
      ${CMAKE_INSTALL_LIBDIR}/pkgconfig
  COMPONENT
    pkgconfig
)

configure_file(socket_wrapper_noop.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper_noop.pc @ONLY)
install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper_noop.pc
  DESTINATION
      ${CMAKE_INSTALL_LIBDIR}/pkgconfig
  COMPONENT
    pkgconfig
)

# cmake config files
configure_file(socket_wrapper-config-version.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper-config-version.cmake @ONLY)
configure_file(socket_wrapper-config.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper-config.cmake @ONLY)
install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper-config-version.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper-config.cmake
    DESTINATION
        ${CMAKE_INSTALL_LIBDIR}/cmake/socket_wrapper
    COMPONENT
        devel
)

add_subdirectory(doc)

=== tests/CMakeLists.txt ===
project(tests C)

include_directories(
  ${CMAKE_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_SOURCE_DIR}/src
  ${CMOCKA_INCLUDE_DIR}
)

# Required for cmocka >= 1.1.6
if (TARGET cmocka::cmocka)
    set(CMOCKA_LIBRARY cmocka::cmocka)
endif()

set(TORTURE_LIBRARY torture)

# RFC862 echo server
add_executable(echo_srv echo_srv.c)
target_compile_options(echo_srv
                       PRIVATE
                           ${DEFAULT_C_COMPILE_FLAGS}
                           -D_GNU_SOURCE)
target_link_libraries(echo_srv ${SWRAP_REQUIRED_LIBRARIES})
if (DEFINED DEFAULT_LINK_FLAGS)
    set_target_properties(echo_srv
                          PROPERTIES
                              LINK_FLAGS ${DEFAULT_LINK_FLAGS})
endif()

add_library(${TORTURE_LIBRARY} STATIC torture.c)
target_compile_options(${TORTURE_LIBRARY}
                       PRIVATE
                           ${DEFAULT_C_COMPILE_FLAGS}
                           -D_GNU_SOURCE)
target_link_libraries(${TORTURE_LIBRARY}
    ${CMOCKA_LIBRARY}
    ${SWRAP_REQUIRED_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT})

add_library(swrap_fake_uid_wrapper SHARED swrap_fake_uid_wrapper.c)
target_compile_options(swrap_fake_uid_wrapper
                       PRIVATE
                           ${DEFAULT_C_COMPILE_FLAGS}
                           -D_GNU_SOURCE)
#target_include_directories(swrap_fake_uid_wrapper
#        PRIVATE ${CMAKE_BINARY_DIR} ${CMOCKA_INCLUDE_DIR})
set(SWRAP_FAKE_UID_WRAPPER_LOCATION "${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_SHARED_LIBRARY_PREFIX}swrap_fake_uid_wrapper${CMAKE_SHARED_LIBRARY_SUFFIX}")

set(SWRAP_THREADED_TESTS
    test_thread_sockets
    test_thread_echo_tcp_connect
    test_thread_echo_tcp_write_read
    test_thread_echo_tcp_sendmsg_recvmsg
    test_thread_echo_udp_send_recv)

set(SWRAP_TESTS
    test_ioctl
    test_tcp_listen
    test_tcp_dup2
    test_fcntl
    test_fcntl_lock
    test_echo_tcp_connect
    test_echo_tcp_bind
    test_echo_tcp_socket_options
    test_echo_tcp_sendmsg_recvmsg
    test_echo_tcp_sendmmsg_recvmmsg
    test_echo_tcp_write_read
    test_echo_tcp_poll
    test_echo_tcp_writev_readv
    test_echo_tcp_get_peer_sock_name
    test_echo_udp_sendto_recvfrom
    test_echo_udp_send_recv
    test_echo_udp_sendmsg_recvmsg
    test_max_sockets
    test_public_functions
    test_close_failure
    test_tcp_socket_overwrite
    test_syscall_uwrap
    ${SWRAP_THREADED_TESTS})

if (HAVE_STRUCT_MSGHDR_MSG_CONTROL)
    set(SWRAP_TESTS ${SWRAP_TESTS} test_sendmsg_recvmsg_fd test_echo_tcp_sendmsg_recvmsg_fd)
endif (HAVE_STRUCT_MSGHDR_MSG_CONTROL)

function(ADD_CMOCKA_TEST_ENVIRONMENT _TEST_NAME)
    if (CMAKE_BUILD_TYPE)
        string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_LOWER)
        if (CMAKE_BUILD_TYPE_LOWER STREQUAL "addresssanitizer")
            find_library(ASAN_LIBRARY
                         NAMES asan)
            if (NOT ASAN_LIBRARY)
                foreach(version RANGE 10 1)
                    if (NOT ASAN_LIBRARY)
                        find_library(ASAN_LIBRARY libasan.so.${version})
                    endif()
                endforeach()
            endif()
        endif()
    endif()

    if (ASAN_LIBRARY)
        list(APPEND PRELOAD_LIBRARIES ${ASAN_LIBRARY})
    endif()
    list(APPEND PRELOAD_LIBRARIES ${SWRAP_FAKE_UID_WRAPPER_LOCATION})
    list(APPEND PRELOAD_LIBRARIES ${SOCKET_WRAPPER_LOCATION})

    if (OSX)
        set(TORTURE_ENVIRONMENT "DYLD_FORCE_FLAT_NAMESPACE=1;DYLD_INSERT_LIBRARIES=${SOCKET_WRAPPER_LOCATION}")
    else ()
        string(REPLACE ";" ":" _TMP_ENV "${PRELOAD_LIBRARIES}")
        set(TORTURE_ENVIRONMENT "LD_PRELOAD=${_TMP_ENV}")
    endif()

    if (CMAKE_BUILD_TYPE)
        string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_LOWER)
        if (CMAKE_BUILD_TYPE_LOWER STREQUAL "addresssanitizer" OR
            CMAKE_BUILD_TYPE_LOWER STREQUAL "threadsanitizer" OR
            CMAKE_BUILD_TYPE_LOWER STREQUAL "undefinedsanitizer")
            list(APPEND TORTURE_ENVIRONMENT "SOCKET_WRAPPER_DISABLE_DEEPBIND=1")
        endif()
    endif()

    set_property(TEST
                    ${_TEST_NAME}
                PROPERTY
                    ENVIRONMENT "${TORTURE_ENVIRONMENT}")
endfunction()

if (CMAKE_SIZEOF_VOID_P EQUAL 4)
    execute_process(
        COMMAND getconf LFS_CFLAGS
        OUTPUT_VARIABLE GETCONF_LFS_CFLAGS
        OUTPUT_STRIP_TRAILING_WHITESPACE)
    # Create a list from the string
    set(LFS_CFLAGS)
    if (GETCONF_LFS_CFLAGS)
        string(REPLACE " " ";" LFS_CFLAGS ${GETCONF_LFS_CFLAGS})
    endif()
    message(STATUS "Enabling large file support for tests: ${LFS_CFLAGS}")
endif()

foreach(_SWRAP_TEST ${SWRAP_TESTS})
    add_cmocka_test(${_SWRAP_TEST}
                    SOURCES ${_SWRAP_TEST}.c
                    COMPILE_OPTIONS ${DEFAULT_C_COMPILE_FLAGS} -D_GNU_SOURCE ${LFS_CFLAGS}
                    LINK_LIBRARIES ${TORTURE_LIBRARY} socket_wrapper_noop
                    LINK_OPTIONS ${DEFAULT_LINK_FLAGS})
    add_cmocka_test_environment(${_SWRAP_TEST})
endforeach()

if (HELGRIND_TESTING)
    find_program(VALGRIND_EXECUTABLE valgrind)
    if (VALGRIND_EXECUTABLE)
        set(VALGRIND_HELGRIND_OPTIONS -v --trace-children=yes --tool=helgrind --error-exitcode=1 --read-var-info=yes --suppressions=${CMAKE_CURRENT_SOURCE_DIR}/helgrind.supp)

        foreach(_TEST ${SWRAP_THREADED_TESTS})
            set(_HELGRIND_TEST "helgrind_${_TEST}")

            add_test(NAME ${_HELGRIND_TEST} COMMAND ${VALGRIND_EXECUTABLE} ${VALGRIND_HELGRIND_OPTIONS} ${CMAKE_CURRENT_BINARY_DIR}/${_TEST})
            if (OSX)
                set_property(
                    TEST
                        ${_HELGRIND_TEST}
                    PROPERTY
                        ENVIRONMENT DYLD_FORCE_FLAT_NAMESPACE=1;DYLD_INSERT_LIBRARIES=${SOCKET_WRAPPER_LOCATION})
            else ()
                set_property(
                    TEST
                        ${_HELGRIND_TEST}
                    PROPERTY
                        ENVIRONMENT LD_PRELOAD=${SOCKET_WRAPPER_LOCATION} SOCKET_WRAPPER_DISABLE_DEEPBIND=1)
            endif()
        endforeach()
    endif()
endif()

# test_swrap_unit (don't use LFS)
add_cmocka_test(test_swrap_unit
                SOURCES test_swrap_unit.c
                COMPILE_OPTIONS ${DEFAULT_C_COMPILE_FLAGS} -D_GNU_SOURCE
                LINK_LIBRARIES ${TORTURE_LIBRARY} socket_wrapper_noop
                LINK_OPTIONS ${DEFAULT_LINK_FLAGS})
add_cmocka_test_environment(test_swrap_unit)

# test_fork_pthread
add_library(thread_deadlock SHARED thread_deadlock.c)
target_link_libraries(thread_deadlock ${CMAKE_THREAD_LIBS_INIT})
target_compile_options(thread_deadlock PRIVATE ${DEFAULT_C_COMPILE_FLAGS})

add_cmocka_test(test_fork_thread_deadlock
                SOURCES test_fork_thread_deadlock.c
                COMPILE_OPTIONS ${DEFAULT_C_COMPILE_FLAGS} -D_GNU_SOURCE
                LINK_LIBRARIES ${TORTURE_LIBRARY} thread_deadlock
                LINK_OPTIONS ${DEFAULT_LINK_FLAGS})
add_cmocka_test_environment(test_fork_thread_deadlock)

=== debian/changelog ===
socket-wrapper (1.4.2-3) unstable; urgency=medium

  * fix-unknown-syscall.diff: Fix patch, fixes FTBFS on arm.

 -- Simon Josefsson <simon@josefsson.org>  Tue, 22 Aug 2023 08:49:40 +0200

socket-wrapper (1.4.2-2) unstable; urgency=medium

  * drop-unknown-syscall.diff: Remove, incorrect fix.
  * fix-unknown-syscall.diff: Add, forwarded version.
  * wrap-and-sort: Add test.
  * manpage-rebuild: Add self-test.
  * Avoid writing to srcdir to reduce extend-diff-ignore.
  * Hurd_PATH_MAX.patch: Use forwarded patch version.

 -- Simon Josefsson <simon@josefsson.org>  Sat, 19 Aug 2023 12:00:28 +0200

socket-wrapper (1.4.2-1) unstable; urgency=medium

  * New upstream release.
  * Make package team maintained.
  * patches: Refresh
  * Build with hardening=+all.
  * Add Rules-Requires-Root: no.
  * Drop obsolete XS-Testsuite.
  * Add Vcs-* fields.
  * Simplify watch file, silencing
    debian-watch-does-not-check-openpgp-signature.
  * Add debian/upstream/signing-key.asc.
  * Add debian/upstream/metadata.
  * copyright: Add myself for debian/* changes.
  * doc: Use asciidoctor for manpage to reduce dependencies.
  * Drop duplicated B-D on libcmocka-dev (alas it is needed even for
    nocheck), and drop version rule (unnecessary since buster).
  * drop-unknown-syscall.diff: Add, unreliable check.
  * tests: Fix LD_PRELOAD.

 -- Simon Josefsson <simon@josefsson.org>  Sun, 06 Aug 2023 20:10:38 +0200

=== debian/control ===
Source: socket-wrapper
Homepage: http://cwrap.org/socket_wrapper.html
Section: devel
Priority: optional
Maintainer: Debian SSSD Team <pkg-sssd-devel@alioth-lists.debian.net>
Uploaders:
 Laszlo Boszormenyi (GCS) <gcs@debian.org>,
 Timo Aaltonen <tjaalton@debian.org>,
 Simon Josefsson <simon@josefsson.org>,
Build-Depends:
 asciidoctor,
 cmake (>= 2.8.8-3~),
 debhelper-compat (= 13),
 dh-buildinfo,
 libcmocka-dev,
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/sssd-team/socket-wrapper.git
Vcs-Browser: https://salsa.debian.org/sssd-team/socket-wrapper
Rules-Requires-Root: no

Package: libsocket-wrapper
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: socket wrapper library
 socket_wrapper is a preload library that makes possible to run several
 instances of the full software stack on the same machine and perform locally
 functional testing of complex network configurations. It passes all socket
 communication over unix domain sockets.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

override_dh_auto_configure:
	dh_auto_configure -- -DUNIT_TESTING=1

override_dh_auto_install:
	dh_auto_install
	asciidoctor -b manpage doc/socket_wrapper.1.adoc \
		-D debian/libsocket-wrapper/usr/share/man/man1

%:
	dh $@  --buildsystem=cmake --builddirectory=$(CURDIR)/obj/

.PHONY: override_dh_auto_configure
.PHONY: override_dh_auto_install

=== debian/tests/control ===
Tests: tests
Depends:
 build-essential,
 cmake (>= 2.8.8-3~),
 libcmocka-dev (>= 0.4.1),
 libsocket-wrapper,
Restrictions: allow-stderr

Tests: adequate
Depends:
 adequate,
 libsocket-wrapper,

Tests: manpage-rebuild
Depends:
 libsocket-wrapper,
Restrictions: superficial

Tests: wrap-and-sort
Depends:
 devscripts,
 python3-debian,
Restrictions: superficial

## socket-wrapper 1.4.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 include(DefineCMakeDefaults)
 include(DefineCompilerFlags)
 
-project(socket_wrapper VERSION 1.4.2 LANGUAGES C)
+project(socket_wrapper VERSION 1.4.3 LANGUAGES C)
 
 # global needed variables
 set(APPLICATION_NAME ${PROJECT_NAME})
@@ -25,7 +25,7 @@
 #     Increment PATCH.
 set(LIBRARY_VERSION_MAJOR 0)
 set(LIBRARY_VERSION_MINOR 4)
-set(LIBRARY_VERSION_PATCH 1)
+set(LIBRARY_VERSION_PATCH 2)
 set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(LIBRARY_SOVERSION ${LIBRARY_VERSION_MAJOR})

=== debian/changelog ===
socket-wrapper (1.4.3-2) unstable; urgency=medium

  [ Simon Josefsson ]
  * Mark our no-soname patch as not needing forwarding.

  [ Helge Deller ]
  * Disable time64 transition.  Closes: #1069450.

 -- Simon Josefsson <simon@josefsson.org>  Tue, 05 Nov 2024 19:40:43 +0100

socket-wrapper (1.4.3-1) unstable; urgency=medium

  * New upstream release.
  * Fix typo in debian/copyright (thanks licenserecon).
  * Use CI job for wrap-and-sort instead of debci.
  * Drop upstreamed fix-unknown-syscall.diff and Hurd_PATH_MAX.patch.
  * Standards-Version: 4.7.0.
  * Fix lintian update-debian-copyright.
  * Refresh no-soname.diff.
  * Drop support for armel+armhf, pending proper #1069450 fix.

 -- Simon Josefsson <simon@josefsson.org>  Mon, 23 Sep 2024 16:41:40 +0200

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
  debhelper-compat (= 13),
  dh-buildinfo,
  libcmocka-dev,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Git: https://salsa.debian.org/sssd-team/socket-wrapper.git
 Vcs-Browser: https://salsa.debian.org/sssd-team/socket-wrapper
 Rules-Requires-Root: no

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all abi=-time64
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DUNIT_TESTING=1

## socket-wrapper 1.4.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # Required cmake version
-cmake_minimum_required(VERSION 3.5.0)
+cmake_minimum_required(VERSION 3.10.0)
 cmake_policy(SET CMP0048 NEW)
 
 # Specify search path for CMake modules to be loaded by include()
@@ -11,7 +11,7 @@
 include(DefineCMakeDefaults)
 include(DefineCompilerFlags)
 
-project(socket_wrapper VERSION 1.4.3 LANGUAGES C)
+project(socket_wrapper VERSION 1.4.4 LANGUAGES C)
 
 # global needed variables
 set(APPLICATION_NAME ${PROJECT_NAME})

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -143,7 +143,7 @@
     add_cmocka_test(${_SWRAP_TEST}
                     SOURCES ${_SWRAP_TEST}.c
                     COMPILE_OPTIONS ${DEFAULT_C_COMPILE_FLAGS} -D_GNU_SOURCE ${LFS_CFLAGS}
-                    LINK_LIBRARIES ${TORTURE_LIBRARY} socket_wrapper_noop
+                    LINK_LIBRARIES ${TORTURE_LIBRARY} ${CMOCKA_LIBRARY} socket_wrapper_noop
                     LINK_OPTIONS ${DEFAULT_LINK_FLAGS})
     add_cmocka_test_environment(${_SWRAP_TEST})
 endforeach()
@@ -178,7 +178,7 @@
 add_cmocka_test(test_swrap_unit
                 SOURCES test_swrap_unit.c
                 COMPILE_OPTIONS ${DEFAULT_C_COMPILE_FLAGS} -D_GNU_SOURCE
-                LINK_LIBRARIES ${TORTURE_LIBRARY} socket_wrapper_noop
+                LINK_LIBRARIES ${TORTURE_LIBRARY} ${CMOCKA_LIBRARY} socket_wrapper_noop
                 LINK_OPTIONS ${DEFAULT_LINK_FLAGS})
 add_cmocka_test_environment(test_swrap_unit)
 
@@ -190,6 +190,6 @@
 add_cmocka_test(test_fork_thread_deadlock
                 SOURCES test_fork_thread_deadlock.c
                 COMPILE_OPTIONS ${DEFAULT_C_COMPILE_FLAGS} -D_GNU_SOURCE
-                LINK_LIBRARIES ${TORTURE_LIBRARY} thread_deadlock
+                LINK_LIBRARIES ${TORTURE_LIBRARY} ${CMOCKA_LIBRARY} thread_deadlock
                 LINK_OPTIONS ${DEFAULT_LINK_FLAGS})
 add_cmocka_test_environment(test_fork_thread_deadlock)

=== debian/changelog ===
socket-wrapper (1.4.4-3) unstable; urgency=medium

  * d/tests: pass CPPFLAGS to cmake in CFLAGS.

 -- Shengqi Chen <harry@debian.org>  Wed, 05 Mar 2025 09:51:46 +0800

socket-wrapper (1.4.4-2) unstable; urgency=medium

  [ Shengqi Chen ]
  * Use non-time64 CFLAGS/CPPFLAGS.

 -- Simon Josefsson <simon@josefsson.org>  Tue, 04 Mar 2025 12:05:04 +0100

socket-wrapper (1.4.4-1) unstable; urgency=medium

  [ наб ]
  * d/control: Build-Depends: remove dh-buildinfo (see #1068809)

  [ Simon Josefsson ]
  * New upstream version 1.4.4
  * Standards-Version: 4.7.2.
  * Bump debian/* copyright years.
  * Fix wrap-and-sort nit.
  * tests: Make building verbose, print CC commands.
  * d/rules:  Harmonize with other *-wrapper packages.
  * Put gcc -dumpspec in build logs.

 -- Simon Josefsson <simon@josefsson.org>  Mon, 03 Mar 2025 21:40:44 +0100

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all abi=-time64

%:
	dh $@ --builddirectory=build

unittest = $(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),,-DUNIT_TESTING=1)

execute_before_dh_auto_build:
	gcc -dumpspecs

execute_after_dh_auto_install:
	asciidoctor -b manpage doc/socket_wrapper.1.adoc \
		-D debian/libsocket-wrapper/usr/share/man/man1

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_VERBOSE_MAKEFILE=ON \
		$(unittest)

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ \
https://ftp.samba.org/pub/cwrap/ \
socket_wrapper-@ANY_VERSION@@ARCHIVE_EXT@

## socket-wrapper 1.5.0

=== debian/changelog ===
socket-wrapper (1.5.0-2) unstable; urgency=medium

  * Merge in 1.4.4-3 changes.
  * salsa-ci: Enable i386/arm jobs.

 -- Simon Josefsson <simon@josefsson.org>  Mon, 18 Aug 2025 14:22:16 +0200

socket-wrapper (1.5.0-1) unstable; urgency=medium

  * New upstream version 1.5.0
  * Refresh patches.

 -- Simon Josefsson <simon@josefsson.org>  Sun, 17 Aug 2025 16:49:23 +0200

## socket-wrapper 1.5.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 include(DefineCMakeDefaults)
 include(DefineCompilerFlags)
 
-project(socket_wrapper VERSION 1.4.4 LANGUAGES C)
+project(socket_wrapper VERSION 1.5.1 LANGUAGES C)
 
 # global needed variables
 set(APPLICATION_NAME ${PROJECT_NAME})
@@ -24,8 +24,8 @@
 #   If the source code was changed, but there were no interface changes:
 #     Increment PATCH.
 set(LIBRARY_VERSION_MAJOR 0)
-set(LIBRARY_VERSION_MINOR 4)
-set(LIBRARY_VERSION_PATCH 2)
+set(LIBRARY_VERSION_MINOR 5)
+set(LIBRARY_VERSION_PATCH 1)
 set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(LIBRARY_SOVERSION ${LIBRARY_VERSION_MAJOR})

=== doc/CMakeLists.txt ===
install(FILES
            socket_wrapper.1
        DESTINATION
            ${CMAKE_INSTALL_MANDIR}/man1)

=== src/CMakeLists.txt ===
project(libsocket_wrapper C)

add_library(socket_wrapper SHARED socket_wrapper.c)
target_include_directories(socket_wrapper
                           PRIVATE
                               ${CMAKE_BINARY_DIR})
target_compile_options(socket_wrapper
                       PRIVATE
                          ${DEFAULT_C_COMPILE_FLAGS}
                          -D_GNU_SOURCE)
if (CMAKE_SIZEOF_VOID_P EQUAL 4)
    target_compile_options(socket_wrapper
                           PRIVATE
                           -D_LARGEFILE64_SOURCE)
endif()

target_link_libraries(socket_wrapper
                      PRIVATE ${SWRAP_REQUIRED_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})

set_target_properties(socket_wrapper
                      PROPERTIES
                          VERSION ${LIBRARY_VERSION}
                          SOVERSION ${LIBRARY_SOVERSION})
if (DEFINED DEFAULT_LINK_FLAGS)
    set_target_properties(socket_wrapper
                          PROPERTIES
                              LINK_FLAGS ${DEFAULT_LINK_FLAGS})
endif()

install(TARGETS socket_wrapper
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

set(SOCKET_WRAPPER_LOCATION "${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_SHARED_LIBRARY_PREFIX}socket_wrapper${CMAKE_SHARED_LIBRARY_SUFFIX}" PARENT_SCOPE)

add_library(socket_wrapper_noop SHARED socket_wrapper_noop.c)
target_include_directories(socket_wrapper_noop
                           PRIVATE
                               ${socket_wrapper_BINARY_DIR}
                           PUBLIC
                               $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
                               $<INSTALL_INTERFACE:include>)
target_compile_options(socket_wrapper_noop
                       PRIVATE
                          ${DEFAULT_C_COMPILE_FLAGS}
                          -D_GNU_SOURCE)
target_link_libraries(socket_wrapper_noop
                      PRIVATE ${SWRAP_REQUIRED_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
set_target_properties(socket_wrapper_noop
                      PROPERTIES
                          VERSION ${NOOP_LIBRARY_VERSION}
                          SOVERSION ${NOOP_LIBRARY_SOVERSION})
if (DEFINED DEFAULT_LINK_FLAGS)
    set_target_properties(socket_wrapper_noop
                          PROPERTIES
                              LINK_FLAGS ${DEFAULT_LINK_FLAGS})
endif()

install(TARGETS socket_wrapper_noop
        EXPORT socket_wrapper_noop-config
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(EXPORT socket_wrapper_noop-config
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/socket_wrapper)

install(
    FILES
        ${CMAKE_CURRENT_SOURCE_DIR}/socket_wrapper.h
    DESTINATION
        ${CMAKE_INSTALL_INCLUDEDIR}
)

=== debian/changelog ===
socket-wrapper (1.5.1-1) unstable; urgency=medium

  * New upstream version 1.5.1
  * salsa-ci: Fix licenserecon usage.
  * Refresh patches.
  * Use watch v5.

 -- Simon Josefsson <simon@josefsson.org>  Mon, 15 Sep 2025 08:04:15 +0200

=== debian/control ===
--- 
+++ 
@@ -8,12 +8,11 @@
  Timo Aaltonen <tjaalton@debian.org>,
  Simon Josefsson <simon@josefsson.org>,
 Build-Depends:
+ debhelper-compat (= 13),
  asciidoctor,
  cmake (>= 2.8.8-3~),
- debhelper-compat (= 13),
- dh-buildinfo,
  libcmocka-dev,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/sssd-team/socket-wrapper.git
 Vcs-Browser: https://salsa.debian.org/sssd-team/socket-wrapper
 Rules-Requires-Root: no

=== debian/tests/control ===
Tests:
 tests,
Depends:
 build-essential,
 cmake (>= 2.8.8-3~),
 libcmocka-dev (>= 0.4.1),
 libsocket-wrapper,
Restrictions:
 allow-stderr,

Tests:
 adequate,
Depends:
 adequate,
 libsocket-wrapper,

Tests:
 manpage-rebuild,
Depends:
 libsocket-wrapper,
Restrictions:
 superficial,

=== debian/watch ===
Version: 5
Source: https://ftp.samba.org/pub/cwrap/
Matching-Pattern: socket_wrapper-@ANY_VERSION@@ARCHIVE_EXT@
Pgpsigurlmangle: s/$/.asc/

## socket-wrapper 1.5.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,5 @@
 # Required cmake version
 cmake_minimum_required(VERSION 3.10.0)
-cmake_policy(SET CMP0048 NEW)
 
 # Specify search path for CMake modules to be loaded by include()
 # and find_package()
@@ -11,7 +10,7 @@
 include(DefineCMakeDefaults)
 include(DefineCompilerFlags)
 
-project(socket_wrapper VERSION 1.5.1 LANGUAGES C)
+project(socket_wrapper VERSION 1.5.2 LANGUAGES C)
 
 # global needed variables
 set(APPLICATION_NAME ${PROJECT_NAME})
@@ -25,7 +24,7 @@
 #     Increment PATCH.
 set(LIBRARY_VERSION_MAJOR 0)
 set(LIBRARY_VERSION_MINOR 5)
-set(LIBRARY_VERSION_PATCH 1)
+set(LIBRARY_VERSION_PATCH 2)
 set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(LIBRARY_SOVERSION ${LIBRARY_VERSION_MAJOR})

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -12,6 +12,11 @@
     set(CMOCKA_LIBRARY cmocka::cmocka)
 endif()
 
+# Check for newer cmocka functions to avoid deprecated warnings
+include(CheckLibraryExists)
+set(CMAKE_REQUIRED_LIBRARIES ${CMOCKA_LIBRARY})
+check_library_exists("${CMOCKA_LIBRARY}" _assert_uint_in_range "" HAVE_ASSERT_UINT_IN_RANGE)
+
 set(TORTURE_LIBRARY torture)
 
 # RFC862 echo server
@@ -23,6 +28,24 @@
 target_link_libraries(echo_srv ${SWRAP_REQUIRED_LIBRARIES})
 if (DEFINED DEFAULT_LINK_FLAGS)
     set_target_properties(echo_srv
+                          PROPERTIES
+                              LINK_FLAGS ${DEFAULT_LINK_FLAGS})
+endif()
+
+# Helper tool to calculate optimal unix_scm_rights_payload configuration
+add_executable(calc_unix_scm_rights_payload calc_unix_scm_rights_payload.c)
+target_compile_options(calc_unix_scm_rights_payload
+                       PRIVATE
+                           ${DEFAULT_C_COMPILE_FLAGS}
+                           -D_GNU_SOURCE)
+target_include_directories(calc_unix_scm_rights_payload
+                           PRIVATE
+                               ${CMAKE_BINARY_DIR})
+target_link_libraries(calc_unix_scm_rights_payload
+    ${SWRAP_REQUIRED_LIBRARIES}
+    ${CMAKE_THREAD_LIBS_INIT})
+if (DEFINED DEFAULT_LINK_FLAGS)
+    set_target_properties(calc_unix_scm_rights_payload
                           PROPERTIES
                               LINK_FLAGS ${DEFAULT_LINK_FLAGS})
 endif()
@@ -148,6 +171,11 @@
     add_cmocka_test_environment(${_SWRAP_TEST})
 endforeach()
 
+# Add compile definition for test that needs to check for newer cmocka function
+if (HAVE_ASSERT_UINT_IN_RANGE)
+    target_compile_definitions(test_echo_tcp_get_peer_sock_name PRIVATE HAVE_ASSERT_UINT_IN_RANGE)
+endif()
+
 if (HELGRIND_TESTING)
     find_program(VALGRIND_EXECUTABLE valgrind)
     if (VALGRIND_EXECUTABLE)
@@ -193,3 +221,54 @@
                 LINK_LIBRARIES ${TORTURE_LIBRARY} ${CMOCKA_LIBRARY} thread_deadlock
                 LINK_OPTIONS ${DEFAULT_LINK_FLAGS})
 add_cmocka_test_environment(test_fork_thread_deadlock)
+
+# Python concurrency reproducer test
+# Skip this test when building with ThreadSanitizer as it causes issues
+if (CMAKE_BUILD_TYPE)
+    string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_LOWER_FOR_PYTHON)
+endif()
+
+find_package(Python3 COMPONENTS Interpreter)
+if (Python3_FOUND AND NOT CMAKE_BUILD_TYPE_LOWER_FOR_PYTHON STREQUAL "threadsanitizer")
+    # Create wrapper script that sets up temporary directory
+    set(PYTHON_TEST_WRAPPER "${CMAKE_CURRENT_BINARY_DIR}/run_python_concurrency_test.sh")
+    file(WRITE ${PYTHON_TEST_WRAPPER}
+"#!/bin/bash
+
+TMPDIR=\$(mktemp -d /tmp/swrap_python_XXXXXX)
+trap 'rm -rf \$TMPDIR' EXIT
+
+export SOCKET_WRAPPER_DIR=\$TMPDIR
+export SOCKET_WRAPPER_DEFAULT_IFACE=10
+
+${Python3_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/python_concurency_reproducer.py
+")
+
+    add_test(NAME test_python_concurrency_reproducer
+             COMMAND bash ${PYTHON_TEST_WRAPPER})
+
+    if (ASAN_LIBRARY)
+        list(APPEND PYTHON_PRELOAD_LIBRARIES ${ASAN_LIBRARY})
+    endif()
+    list(APPEND PYTHON_PRELOAD_LIBRARIES ${SWRAP_FAKE_UID_WRAPPER_LOCATION})
+    list(APPEND PYTHON_PRELOAD_LIBRARIES ${SOCKET_WRAPPER_LOCATION})
+
+    if (OSX)
+        set(PYTHON_TORTURE_ENVIRONMENT "DYLD_FORCE_FLAT_NAMESPACE=1;DYLD_INSERT_LIBRARIES=${SOCKET_WRAPPER_LOCATION}")
+    else ()
+        string(REPLACE ";" ":" _PYTHON_TMP_ENV "${PYTHON_PRELOAD_LIBRARIES}")
+        set(PYTHON_TORTURE_ENVIRONMENT "LD_PRELOAD=${_PYTHON_TMP_ENV}")
+    endif()
+
+    if (CMAKE_BUILD_TYPE)
+        string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_LOWER)
+        if (CMAKE_BUILD_TYPE_LOWER STREQUAL "addresssanitizer" OR
+            CMAKE_BUILD_TYPE_LOWER STREQUAL "threadsanitizer" OR
+            CMAKE_BUILD_TYPE_LOWER STREQUAL "undefinedsanitizer")
+            list(APPEND PYTHON_TORTURE_ENVIRONMENT "SOCKET_WRAPPER_DISABLE_DEEPBIND=1")
+        endif()
+    endif()
+
+    set_property(TEST test_python_concurrency_reproducer
+                 PROPERTY ENVIRONMENT "${PYTHON_TORTURE_ENVIRONMENT}")
+endif()

=== debian/changelog ===
socket-wrapper (1.5.2-2) unstable; urgency=medium

  * Add python3 as Depends for tests
  * Fix manpage-rebuild autopkgtest

 -- Simon Josefsson <simon@josefsson.org>  Sun, 14 Dec 2025 09:14:54 +0100

socket-wrapper (1.5.2-1) unstable; urgency=medium

  * New upstream version 1.5.2 (Closes: #1122651)
  * Refresh patch
  * Drop Rules-Requires-Root: no
  * Drop Salsa arm builds

 -- Simon Josefsson <simon@josefsson.org>  Fri, 12 Dec 2025 10:25:55 +0100

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,6 @@
 Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/sssd-team/socket-wrapper.git
 Vcs-Browser: https://salsa.debian.org/sssd-team/socket-wrapper
-Rules-Requires-Root: no
 
 Package: libsocket-wrapper
 Architecture: any

=== debian/tests/control ===
--- 
+++ 
@@ -5,6 +5,7 @@
  cmake (>= 2.8.8-3~),
  libcmocka-dev (>= 0.4.1),
  libsocket-wrapper,
+ python3,
 Restrictions:
  allow-stderr,
